from turtle import *
import math

Screen().screensize(1200,700, "white")
speed(0)

pirosak = [5, 14, 32, 33, 51, 52, 84]
zoldek = [1, 2, 6, 7, 8, 9, 10, 15, 16, 17, 18, 34, 35, 36, 53, 54, 85, 86, 118]
#speed("fastest")

def teglalap(a, b):
    begin_fill()
    for i in range(2):
        forward(a)
        right(90)
        forward(b)
        right(90)
    end_fill()

def atom(n,h):
    width(1)
    color("black")
    fillcolor("lightblue")
    if (n in pirosak):
        fillcolor("red")
    if (n in zoldek):
        fillcolor("lightgreen")
    teglalap(h,h*1.5)
    up()
    forward(h/2)
    left(90)
    back(h)
    down()
    write(n, align="center")
    up()
    forward(h)
    right(90)
    back(h/2)    
    down()

def jobbraleptet(h):
    up()
    forward(h)
    down()

def balraleptet(h):
    jobbraleptet(-h)

def leleptet(h):
    up()
    left(90)
    back(h)
    right(90)
    down()

def felleptet(h):
    leleptet(-h)

def rombusz(h):
    x=xcor()
    y=ycor()
    goto(x+h,y-h*3)
    goto(x+h,y-h*4.5)
    goto(x,y-h*1.5)
    goto(x+h,y-h*4.5)
    up()
    goto(x+h,y-h*3)
    down()
   

def periodusos(h):
    atom(1,h)
    jobbraleptet(h*17)
    atom(2,h)
    balraleptet(h*17)
    leleptet(h*1.5)
    sz=3
    for i in range(2):
        for j in range(2):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        jobbraleptet(h*10)
        for j in range(6):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        balraleptet(h*18)
        leleptet(h*1.5)
    for i in range(2):
        for j in range(18):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        balraleptet(h*18)
        leleptet(h*1.5)
    for i in range(2):
        for j in range(2):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        rombusz(h)
        for j in range(15):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        balraleptet(h*15)
        leleptet(-h*3)
        for j in range(15):
            atom(sz, h)
            sz+=1
            jobbraleptet(h)
        balraleptet(h*18)
        leleptet(h*1.5)

def hatter():
    balraleptet(600)
    felleptet(350)
    fillcolor("#E0B898")
    teglalap(1200,700)
    jobbraleptet(880)
    right(90)
    forward(400)
    left(90)
    fillcolor("#C88048")
    begin_fill()
    goto(580,-350)
    goto(-600,-350)
    goto(-600,-50)
    goto(280,-50)
    end_fill()

def tabla(a,b):
    right(45)
    fillcolor("#006848")
    width(3)
    begin_fill()
    for i in range(2):
        forward(a)
        right(45)
        forward(b)
        right(135)
    end_fill()
    left(45)

def lab(sz,m):
    for i in range(2):
        penup()
        forward(sz)
        right(90)
        pendown()
        forward(m)
        right(90)

def paralelogramma(sz,h):
    begin_fill()
    for i in range(2):
        forward(sz)
        right(45)
        forward(h)
        right(135)
    end_fill()

def pad(sz,h,m):
    fillcolor("#A86840")
    width(3)
    lab(sz,m)
    paralelogramma(sz,h)
    right(45)
    forward(h)
    left(45)
    lab(sz,m)
    left(135)
    forward(h)
    right(135)

def szek(sz,m):
    pad(sz,sz,m/3)
    left(90)
    forward(m*2/3)
    right(135)
    paralelogramma(sz,m*1/3)
    forward(sz)
    right(45)
    forward(m*2/3)
    right(135)
    forward(sz)
    right(135)

def padsor(m):
    pad(m,4*m,m)
    leleptet(m/2)
    balraleptet(m/2)
    for i in range(2):
        szek(m,m*2)
        leleptet(m*1.5)
        jobbraleptet(m*1.5)
    balraleptet(m*3.5)
    felleptet(m*3.5)

def padok(m,db):
    for i in range(db):
        padsor(m)
        jobbraleptet(4*m)

def tablo1():
    width(1)
    fillcolor("white")
    teglalap(400, 300)
    jobbraleptet(20)
    leleptet(10)
    periodusos(20)

def level(m):
    width(2)
    color("green")
    fillcolor("lightgreen")
    right(45)
    begin_fill()
    for i in range(2):
        circle(m,extent = 90)
        left(90)
    end_fill()
    left(45)
    forward(m/2)
    left(45)
    forward(m*0.4)
    back(m*0.4)
    right(90)
    forward(m*0.4)
    back(m *0.4)
    left(45)
    forward(m/2)
    left(45)
    forward(m/4)
    back(m/4)
    right(90)
    forward(m/4)
    back(m/4)
    left(45)
    forward(m*0.4)
    back(m+m*0.4)

def levelek(l,db):
    for i in range(db):
        level(l)
        right(20)
    left((db+1)*20)
    for i in range(db-1):
        level(l)
        left(20)
    right(db*20)

def fa(n,h,l):
    color("#A86840")
    width(2)
    if (n==1):
        forward(h)
        level(l)
        color("#A86840")
        back(h)
    else:
        if (n==2):
            forward(h)
            left(30)
            fa(n-1,h/3,l)
            right(60)
            fa(n-1,h/3,l)
            left(30)
            levelek(l,n)
            color("#A86840")
            back(h)
        else:
            forward(h)
            left(30)
            fa(n-1,h/3,l)
            right(60)
            fa(n-1,h/3,l)
            left(30)
            levelek(l,n)
            color("#A86840")
            back(h/2)
            right(30)
            fa(n-2,h/6,l)
            left(30)
            back(h/2)

def nyil(m):
    width(2)
    color("black")
    forward(2*m)
    left(45)
    back(m)
    forward(m)
    right(90)
    back(m)
    forward(m)
    left(45)

def ugrik(x,y):
    up()
    goto(x,y)
    down()
    

def tablo2():
    fillcolor("white")
    teglalap(400, 300)
    ugrik(-80,80)
    left(90)
    fa(1,100,20)
    ugrik(50,80)
    fa(3,100,20)
    ugrik(180,80)
    fa(5,100,20)
    ugrik(-35,130)
    right(90)
    nyil(20)
    jobbraleptet(100)
    nyil(20)

def butorok():
    penup()
    goto(320,200)
    pendown()
    tabla(300,200)
    up()
    goto(-500,-30)
    down()
    padok(50,4)
    leleptet(70)
    jobbraleptet(100)
    pad(50,200,50)

def tablok():
    up()
    goto(-570,340)
    down()
    tablo1()
    up()
    goto(-130,340)
    down()
    tablo2()

def tanterem(): 
    hatter()
    butorok()
    tablok()

tanterem()

penup()
forward(500)

done()
    



